#pragma once

#include <algorithm>
#include <map>
#include <vector>
#include <functional>

#include "raster.hpp"
#include "modulo.hpp"

enum class Direction {Hor, Vert};

struct Exchange 
{
    Section section; // The region to be exchanged, per lattice coords

    int where; // Section to send/receive to
    int tag;

    Exchange() {}
    Exchange(int rs, int cs, int height, int width, int where, int tag): section{rs, cs, height, width}, where(where), tag(tag) { /*NO IMPL*/ }
    Exchange(Section s, int where, int tag): section{s}, where(where), tag(tag) { /*NO IMPL*/ }
};

struct Section_exchange
{
    std::vector<Exchange> send;
    std::vector<Exchange> recv;
};

std::vector<Section_exchange> determine_exchanges(std::vector<Section>& sections, Lattice& lattice);
