#pragma once

#include <functional>
#include <iostream>
#include <cmath>

#include "raster.hpp"
#include "indexing.hpp"


constexpr float LAMBDA = -1.0;

constexpr float c[6][2] = {
    {0, 1}, {0.866025, 0.5}, {0.866025, -0.5},
    {0, -1},{-0.866025, -0.5}, {-0.866025, 0.5}
};

/**
 * @brief Perform the propagation step of LBM
 * 
 * @param task A raster object to perform calculation on
 */
void propagate(Raster task, Section global_section);

/**
 * @brief Perform the collision step of LBM
 * 
 * @param task A raster object to perform calculation on
 */
void collide2(Raster task, std::function<void(Section&, int, int, int, float&)> apply_force);

// Different force functions
constexpr int CHANNEL = 100;
constexpr float force[2] = {0.0, 1e-5};   /* Magnitude of external force */

void channel_force(Section& section, int row, int col, int i, float& delta_N);