#pragma once
#include <mpi.h>
#include <map>

#include "raster.hpp"

#include "exch_plan.hpp"
#include "raster.hpp"

MPI_Datatype init_section_type();

MPI_Datatype init_exchange_type();

MPI_Datatype init_point_type();


//TODO: Increase key to include lattice dims width. This enables reuse across all border exchanges as well
class Lattice_type_factory {

    std::map<uint64_t, MPI_Datatype> subsec_types;
    std::map<uint64_t, MPI_Datatype> local_types;

    MPI_Datatype lpoint_type;

    // We assume 16 bits will be sufficient to express the dims of a section. 
    uint64_t map_key(int lat_width, int sec_height, int sec_width) {return static_cast<long>(lat_width) << 32 | static_cast<long>(sec_height) << 16 | static_cast<long>(sec_width);}  
public:
    Lattice_type_factory(MPI_Datatype lpoint_type): lpoint_type(lpoint_type) {};
    
    Lattice_type_factory(const Lattice_type_factory&) = delete;
    Lattice_type_factory(const Lattice_type_factory&&) = delete;

    ~Lattice_type_factory();

    MPI_Datatype subsec_type(const Lattice& lat, const Section& sec, int border);
};