#pragma once
#include <algorithm>
#include <vector>

#include "raster.hpp"

/**
 * @brief Generate sections by creating a grid
 * 
 * @param lattice The lattice to partition
 * @param dims The dimmentions of each grid cell [height, width], the last in each direction can be smaler
 * @return std::vector<Raster> 
 */
std::vector<Section> partition_grid(Lattice& lattice, std::pair<int, int> dims, bool filterEmpty = false);