#pragma once
#include <algorithm>
#include <vector>

#include "raster.hpp"

/**
 * @brief Generate sections using a balanced recursion strategy
 * 
 * @param lattice The lattice to partition
 * @param depth The recursion depth for splitting, we will get 2^n sections from this
 * @return std::vector<Section> 
 */
std::vector<Section> partition_rec2(Lattice& lattice, int depth, double fluid_cost = 1.0, double solid_cost = 0.0);