#include "section.hpp"

std::ostream& operator<<(std::ostream& os, const Section& sec) {
    os << std::fixed << std::setprecision(0)
                << "{" << sec.tl_col << ", " << sec.tl_row << "}, "
                << "{" << sec.br_col << ", " << sec.br_row << "}, "
                << sec.width << " " << sec.height;

    return os;
}

// Checking both height/width and br_X should not be req,
// But probably not a perf issue.
bool operator==(const Section& lhs, const Section& rhs) {
    return  lhs.tl_row == rhs.tl_row && 
            lhs.tl_col == rhs.tl_col &&
            lhs.br_row == rhs.br_row && 
            lhs.br_col == rhs.br_col && 
            lhs.height == rhs.height &&
            lhs.width == rhs.width;           
}
